/*
 * template-multi.c
 * (C)2000 tutimura@nn.iij4u.or.jp
 */

#define    GLOBAL_VALUE_DEFINE  /* main() ޤॽǤΤ */
#include "template-multi.h"


void print_usage( void ) {
    printf( "usage: %s [-a] [-b] [number]\n", command_name );
    printf( "  options\n"
            "  -a : ascii\n"
            "  -b : binary\n"
    );
}


int main( int argc, char *argv[] ) {
    int aflag = 0, bflag = 0;
    char *cvalue = NULL;
    int index;
    int c;

    command_name = argv[0];
    opterr = 0;

    while ( (c=getopt(argc,argv,"abc:")) != EOF ) {
        switch (c) {
        case 'a':
            aflag = !aflag;
            break;
        case 'b':
            bflag = !bflag;
            break;
        case 'c':
            cvalue = optarg;
            break;
        case '?':
        default:
            fprintf ( stderr, "Unknown option `-%c'.\n", optopt );
            print_usage();
            return EXIT_FAILURE;
        }
    }
    printf( "    a = %d, b = %d, c = '%s'\n", aflag, bflag, cvalue );
    
    for ( index=optind; index<argc; index++ ) {
        printf( "  Non-option argument %s\n", argv[index] );
    }
    return EXIT_SUCCESS;
}
