/*
 * This is a sample code, but useful.
 */

#include "template-multi.h"

void *xmalloc( size_t size ) {
    void *s;

    if ( size == 0 ) size++;
    if ( (s=malloc(size)) == NULL ) {
	fprintf( stderr, "malloc : Not enough memory.\n" );
	exit( EXIT_FAILURE );
    }
    return s;
}


void *xcalloc( size_t nobj, size_t size ) {
    void *s;

    if ( nobj == 0 ) nobj++;
    if ( size == 0 ) size++;
    if ( (s=calloc(nobj,size)) == NULL ) {
        fprintf( stderr, "calloc : Not enough memory.\n" );
        exit( EXIT_FAILURE );
    }
    return s;
}


void *xrealloc( void *ptr, size_t size ) {
    void *s;

    if ( (s=realloc(ptr,size)) == NULL && size != 0 ) {
        fprintf( stderr, "realloc : Not enough memory.\n" );
        exit( EXIT_FAILURE );
    }
    return s;
}


char *xstrdup( const char *s ) {
    if ( s == NULL ) s = "";
    return strcpy( xmalloc(strlen(s)+1), s );
}


FILE *xfopen( const char *name, const char *mode ) {
    FILE *fp;

    if ( (fp=fopen(name,mode)) == NULL ) {
        fprintf( stderr, "fopen : Can't open '%s'.\n", name );
        exit( EXIT_FAILURE );
    }
    return fp;
}
